<template>
  <base-card>
    <form @submit.prevent="addNewResource">

      <div class="form-control">
        <label>Title</label>
        <input type="text" ref="titleInput">
      </div>
      <div class="form-control">
        <label>Description</label>
        <textarea rows="5" ref="descInput"></textarea>
      </div>
      <div class="form-control">
        <label>Link</label>
        <input type="text" ref="linkInput">
      </div>
      <div class="form-control">
        <base-button type="submit">Add resource</base-button>
      </div>
    </form>
  </base-card>
  <teleport to="body">
    <base-modal v-if="inputIsInvalid" title="Invalid Input!">
      <template #default>
        <p>Unfortunately, at least one input value is invalid.</p>
        <p>Please, check all inputs and make sure you enter at least a few characters into each input field.</p>
      </template>
      <template #actions>
        <base-button @click="closeModal">Okey</base-button>
      </template>
    </base-modal>
  </teleport>
</template>

<script>
export default {
  name: "AddResource",
  components: {},

  inject:['addResource'],
  data(){
    return {
      inputIsInvalid: false
    };
  },
  methods:{
    addNewResource(){
      const title = this.$refs.titleInput.value;
      const desc = this.$refs.descInput.value;
      const link = this.$refs.linkInput.value;

      if(title.trim() === '' || desc.trim() === '' || link.trim() === ''){
        this.inputIsInvalid = true;
        return;
      }
      this.addResource(title,desc,link);
    },
    closeModal(){
      this.inputIsInvalid = false;
    },
  },


}
</script>

<style scoped>
label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  padding: 0.15rem;
  border: 1px solid #ccc;
}

input:focus,
textarea:focus {
  outline: none;
  border-color: #3a0061;
  background-color: #f7ebff;
}

.form-control {
  margin: 1rem 0;
}
</style>